<%option explicit%>
<%response.buffer=true%>
<!--#include file="admin$db.asp"-->
<%ShopOpenDatabase dbc%>
<!--#include file="help/shoph_editrecord.asp"-->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Edit Translate Product Features Page
'*********************************************************************************

ShopCheckAdmin ""
dim Addaction, Updateaction, Deleteaction
dim rstemp
dim which
dim IDField
dim DBTable
dim translatetable
dim languages, langcount, url
dim strlanguage, featurename, featurecaption, featureid
dim helpfile
SetSess "currenturl", "shopa_edittranslateprodfeatures.asp"
Addaction = Request.form("add")
Updateaction = Request.form("update")
SError = ""
Deleteaction = request("delete")
GetInputValues
if DeleteAction<>"" then
   '700 - 2010.04.22 - cross site script security enhancement
   verifygenpredefinedsecuritycode request("genpredefinedsecuritycode")

   DeleteRecord
end if
if Addaction = "" and Updateaction = "" then
   AdminPageHeader
   SetDefaultvalues
   GenerateForm
   AdminPageTrailer
else
   '700 - 2010.04.22 - cross site script security enhancement
   verifygenpredefinedsecuritycode request("genpredefinedsecuritycode")

   AdminPageHeader
   Validatefields
   if SError = "" then
      UpdateRecord
   end if
   GenerateForm
   AdminPageTrailer
end if
ShopCloseDatabase dbc

sub GetInputValues
   ' ID, allows editing a record
   which = request.querystring("which")

   '6.09 - Precautionary Security Fix
   if which > "" then
      if not isnumeric(which) then
         ShopError "ID must be numeric"
      end if
   end if

   IDField = request.querystring("IDField")
   if IDField = "" then
      IDField = "translateid"
   end if
   DBTable = request.querystring("table")
   if DBTable = "" then DBTable = "translateprodfeatures"
   featureid = request.querystring("id")
   url = request("url")
   if url = "" then
      url = GetSess("currenturl")
   end if
   ValidateTable
   dim force
   force = "Yes"
   GetLanguages languages, langcount, force
end sub

sub ValidateTable
   'See if user has access to this table
   dim UserTables, i
   dim tablecount
   if GetConfig("XRestrictAdminTables")<>"Yes" then exit sub
   UserTables = GetSess("UserTables")
   if isnull(UserTables) then
      exit sub
   end if
   if UserTables = "" then
      exit sub
   else
      UserTables = split(GetSess("UserTables"), ",", -1, 1)
   end if
   tablecount = ubound(UserTables)
   for i = 0 to tablecount
      if ucase(DBTable) = ucase(Usertables(i)) then
         exit sub
      end if
   next
   DBTable = ""
   ShopError GetLang("langEditSelectFail")
end sub

' Get the specific record and then generate form based on this record
sub GenerateForm
   dim sqltemp
   if which <> "" then
      sqltemp = "select * from " & DBTable
      sqltemp = sqltemp & " where " & IDField & "=" & which
      Set rstemp = Server.CreateObject("ADODB.Recordset")

      '701 - 2011.12.07 - Enhancement: Speed up admin pages
      rstemp.open sqltemp, dbc, adOpenStatic, adLockReadOnly
   end if
   DisplayForm
   if which <> "" then
      rstemp.close
      set rstemp = nothing
   end if
end sub

sub DisplayForm()
   if which <> "" then
      featurecaption = rstemp("featurecaption")
      featurename = rstemp("featurename")
      strlanguage = rstemp("lang")
      featureid = rstemp("id")
   end if
%>
<table width='100%' cellpadding="0" cellspacing="0">
  <tr>
    <td valign='top' align='left'><%ShopWriteHeader "Product Features Setup"%></td>
    <td valign='top' align="right"><table>
        <tr>
          <%
   if which<>"" then
      htmlwrite "<td align='center'><a href='shopa_editrecord.asp?which=" & which & "&table=" & DBTable & "&IDField=" & IDField &"'><img src='images/admin/main/edit-24.gif' border=0></a></td>"
   end if
   htmlwrite "<td align='center'><a href='shopa_editdisplay.asp?page="& GetSess("pagenumberaddproduct") &"&which=" & which & "&table=" & DBTable &"'><img src='images/admin/main/arrow_left_blue.gif' border=0></a></td></tr><tr>"
   if which <> "" then
      htmlwrite "<td><a href='shopa_editrecord.asp?which=" & which & "&table=" & DBTable & "&IDField=" & IDField &"'>" & GetLang("langadminadvanced") & " " & GetLang("LangCommonEdit") & "</a></td>"
   end if
   htmlwrite "<td><a href='shopa_editdisplay.asp?page="& GetSess("pagenumberaddproduct") &"&which=" & which & "&table=" & DBTable &"'>Back To " & ucase(left(DBTable, 1)) & right(DBTable, len(DBTable) - 1) & "</a></td>"
%>
        </tr>
      </table></td>
  </tr>
  <tr>
    <td colspan='2' align='center'><%ShopWriteError SError%></td>
  </tr>
</table>
<%
   htmlwrite "<form name=""editform"" action=""" & GetSess("currenturl") & "?which=" & which & "&IDField=" & IDField & "&table=" & DBTable & """ method=""POST"">"

   '700 - 2010.04.22 - cross site script security enhancement
   htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"

   GenerateDisplayHeader "Product Feature Translation Information"
   GenerateDisplayBodyHeader
   htmlwrite "<table>"
   htmlwrite tablerow & tablecolumn & GetLang("LangLanguage") & tablecolumnend & tablecolumn
   GenerateSelectNV languages, strlanguage, "lang", langcount, GetLang("Langcommonselect")
   GenHelpIcon("document.all.help_translateprodfeatures_language")
   htmlwrite Tablecolumnend & TableRowEnd
   formateditrow "Feature id", "id", featureid, "document.all.help_translateprodfeatures_featureid"
   FormatEditRow GetLang("LangProductFeature") & " " & GetLang("langcommoncaption"), "featurecaption", featurecaption, "document.all.help_translateprodfeatures_caption"
   FormatEditRow GetLang("LangProductFeature") & " " & GetLang("LangCommonName"), "featurename", featurename, "document.all.help_translateprodfeatures_name"
   htmlwrite TableDefEnd
   htmlwrite "<center>"
   if which<>"" then
      htmlwrite "&nbsp;&nbsp;<input class=""submitbtn"" type=submit name=Update value='" & GetLang("LangEditUpdateRecord") & "'>"
      htmlwrite "<input class=""submitbtn"" type=submit name=add value='" & GetLang("LangEditCopy") & "'>"
      '6.50 - moved delete button to same line as add and update
	  '700 - 2010.06.18 - Enhancement: Delete record notification
      htmlwrite "&nbsp;&nbsp;<input class=""submitbtn"" onclick='return doDeleteWarning()' type=submit name=Delete value='" & GetLang("LangCommonDelete") & "'>"
      htmlwrite "<p align=center>"
      htmlwrite "</p>"
   else
      htmlwrite "<input class=""submitbtn"" type=submit name=add value='" & GetLang("LangEditAdd") & "'>"
   end if
   htmlwrite "</form></center>"
   GenerateDisplayBodyFooter
   gethelp "translateprodfeatures"
end sub

sub UpdateRecord
   dim sqltemp, rc
   '6.50 - broadened defintion of IF statement to cover cases where xmysql hasn't been set
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      MYSQLProcessrecord updateaction, dbc, DBTable, IDField, which
      exit sub
   end if
   if updateaction<>"" then
      '701 - 2011.12.05 - Bug Fix: SQL DB: Not able to insert value to new translate record.
      'sqltemp = "select * from " & DBTable
      'sqltemp = sqltemp & " where " & IDField & "=" & which
      'set rstemp = Server.createobject("ADODB.Recordset")
      'rstemp.open sqltemp, dbc, 1, 3
      'rstemp.Update
   else
      CheckForDuplicate rc
      if rc<>0 then exit sub
      set rstemp = Server.createobject("ADODB.Recordset")
      rstemp.open DBTable, dbc, adOpenKeyset, adLockOptimistic
      rstemp.AddNew

      '701 - 2011.12.05 - Bug Fix: SQL DB: Not able to insert value to new translate record.
	  rstemp.update
	  which = rstemp(IDField)
	  rstemp.close
	  set rstemp = nothing
   end if

   '701 - 2011.12.05 - Bug Fix: SQL DB: Not able to insert value to new translate record.
   sqltemp = "select * from " & DBTable
   sqltemp = sqltemp & " where " & IDField & "=" & which
   set rstemp = Server.createobject("ADODB.Recordset")
   rstemp.open sqltemp, dbc, adOpenKeyset, adLockOptimistic
   rstemp.Update

   GenerateUpdateSQL
   which = rstemp(IDField)
   rstemp.close
   set rstemp = nothing
   SError = SError & "<br /><b>" & GetLang("LangEdit03") & "</b>"
end sub

sub GenerateUpdateSQL()
   dim howmanyfields
   dim fieldname, fieldvalue, fieldtype
   dim i
   howmanyfields = rstemp.fields.count -1
   rstemp.update
   for i = 1 to howmanyfields
      fieldname = rstemp(i).name
      fieldtype = rstemp(i).type
      fieldvalue = request.form(fieldname)
      EUpdateField fieldname, fieldvalue
   next
   rstemp.update
end sub

sub EUpdateField (fieldname, fieldvalue)
   on error resume next
   if fieldvalue = "" then
      rstemp(Fieldname) = NULL
      exit sub
   end if

   if ucase(fieldvalue) = "NULL" then
      rstemp(Fieldname) = NULL
   else
      rstemp(Fieldname) = fieldvalue
   end if
end sub

' Find the first record so rest of code works
sub SetDefaultvalues
   dim sql, rs
   if featureid = "" then exit sub
   sql = "select * from prodfeatures where id=" & featureid
   Set rs = Server.CreateObject("ADODB.Recordset")

   '701 - 2011.12.07 - Enhancement: Speed up admin pages
   rs.open sql, dbc, adOpenStatic, adLockReadOnly

   if not rs.eof then
      featurecaption = rs("featurecaption")
      featurename = rs("featurename")
   end if
   CloseRecordSet rs
end sub

sub DeleteRecord
   dim sql, url
   sql = "delete from " & DBTable & " where " & IDField & "=" & which
   dbc.execute(sql)
   url = "shopa_editdisplay.asp?table=" & DBTable
   ResponseRedirect url
end sub

' New to find which table and which record
sub GetFormFields
end sub

sub GetExistingProduct
   dim rs, sql
   sql = "Select " & realname & " from " & table & " where " & IDField & "=" & recordid
   response.flush
   Set rs = Server.CreateObject("ADODB.Recordset")

   '701 - 2011.12.07 - Enhancement: Speed up admin pages
   rs.open sql, dbc, adOpenStatic, adLockReadOnly

   if not rs.eof then
      textdata = rs(realname)
   end if
   CloseRecordSet rs
end sub

' Get languages from language file or array
' Do not include default laqnguage
sub GetLanguages (languages, langcount, force)
   dim cid, name, catSQL, i, defaultlang
   dim maxlangs, catrs, mylink
   langcount = 0
   maxlangs = 20
   defaultlang = lcase(GetConfig("xlanguage"))
   redim languages(maxlangs)
   catSQL = "SELECT lang from languages GROUP BY lang"
   Set catrs = Server.CreateObject("ADODB.Recordset")

   '701 - 2011.12.07 - Enhancement: Speed up admin pages
   catrs.open catsql, dbc, adOpenStatic, adLockReadOnly

   do while not catrs.eof and langcount<maxlangs
      name = catrs("lang")
      if lcase(name)<>defaultlang then
         languages(langcount) = name
         langcount = langcount + 1
      end if
      catrs.MoveNext
   loop
   CloseRecordSet catrs
end sub

' check categoryid and language match on adding a record
sub CheckForDuplicate (rc)
   rc = 0
   dim strlanguage, rs, featureid
   featureid = request("id")

   '6.09 - Precautionary Security Fix
   if featureid > "" then
      if not isnumeric(featureid) then
         ShopError "Feature ID must be numeric"
      end if
   end if

   strlanguage = request("lang")
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   sql = "select * from " & DBTable & " where lang="& sqlserverprefixn &"'"& strlanguage & "'"
   sql = sql & " and id=" & featureid
   Set rs = Server.CreateObject("ADODB.Recordset")

   '701 - 2011.12.07 - Enhancement: Speed up admin pages
   rs.open sql, dbc, adOpenStatic, adLockReadOnly

   if not rs.eof then
      SError = SError & "<br />" & GetLang("langrecordexists")
      rc = 4
   end if
   CloseRecordSet rs
end sub

sub Validatefields
   dim strlanguage, rs, featureid
   featureid = request("id")

   '6.09 - Precautionary Security Fix
   if featureid > "" then
      if not isnumeric(featureid) then
         SError = SError & "<br />" & "Feature ID must be numeric"
      end if
   end if

   strlanguage = request("lang")
   if strlanguage = GetLang("langcommonselect") then
      strlanguage = ""
   end if
   if strlanguage = "" then
      SError = SError & "<br />" & GetLang("LangLanguage") & " " & GetLang("langcustrequired")
   end if
   if featureid = "" then
      SError = SError & "<br />" & "Featureid " & GetLang("langcustrequired")
   end if
end sub
%>