<%option explicit%>
<%response.buffer=true%>
<!-- #include file="admin$db.asp" -->
<%ShopOpenDatabase dbc%>
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' List all Language records for a specific product
'*********************************************************************************

dim which, DBTable
dim fieldnames, fieldcount, IDField
dim scriptresponder, keyfield, viewresponder, keytable
ShopCheckAdmin " shopa_editdisplay.asp"
which = request("which") ' specific product/category
if not isnumeric(which) then
   which = ""
end if
DBTable = request("table")

adminpageheader
SetFieldnames ' find out fields in table
SetupTableSpecificvalues DBTable ' setup table specific values
GenerateSQL sql ' generate sql for list
DisplayaddRecordLink ' always have an add record link
DisplayRecorddetails ' display all records
DisplayFormTrailer ' put out trailer
adminpagetrailer
ShopCloseDatabase dbc

' Get all fields from table
sub SetFieldNames
   dim fSql, fieldname
   dim rs
   dim fldname
   redim Fieldnames(200)
   FSQL = "SELECT * FROM " & lcase(DBTable)
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open fSQL, dbc, adOpenDynamic, adLockOptimistic
   for each fldName in rs.Fields
      Fieldname = fldName.name
      if lcase(fieldname) = "extendeddesc" or lcase(fieldname) = "cdescription" then
      else
         Fieldnames(fieldcount) = fieldname
         fieldcount = fieldcount + 1
      end if
   next
   CloseRecordSet rs
   IDField = Fieldnames(0)
end sub

' write field details
sub DisplayFormHeader (fields, fieldcount)
   dim i
   response.write REportTableDEf
   response.write "<tr bgcolor='#9999CC'>"
   response.write ReportHeadColumn & GetLang("langcommonedit") & ReportHeadColumnEnd
   for i = 0 to fieldcount -1
      if i<>0 then
         response.write ReportHeadColumn & fieldnames(i) & ReportHeadColumnEnd
      end if
   next
   response.write ReportRowEnd
end sub

' For every record , display record
sub DisplayRecordDetails
   dim total, rs
   total = 0
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if rs.eof then
      ShopWriteError GetLang("LangNoRecords")
      CloseRecordSet rs
      exit sub
   end if
   DisplayFormHeader fieldnames, fieldcount ' display header
   do while not rs.eof
      WriteReportDetailrow rs, fieldnames, fieldcount
      total = total + 1
      rs.movenext
   loop
   CloseRecordSet rs
end sub

' format one record. The first field is the autonumber field
' generate a link to edit prtogram for it
sub WriteReportDetailrow (rs, fieldnames, fieldcount)
   dim i, id
   dim fieldvalue, fieldname, my_link, keyid
   response.write ReportDetailRow
   for i = 0 to fieldcount -1
      id = rs(0)
      fieldname = fieldnames(i)
      fieldvalue = rs(fieldname)
      keyid = rs(keyfield)
      if i = 0 then
         my_link = scriptresponder & "?table=" & DBTable & "&which=" & id & "&IDField=" & fieldname
         fieldvalue = "<a href=" & my_link &">" & id & "</a>"
      end if
      response.write ReportDetailColumn & fieldvalue & ReportDetailColumnEnd
   next
   my_link = viewresponder & "?table=" & keytable & "&which=" & keyid & "&IDField=" & keyfield
   fieldvalue = "<a href=" & my_link &">" & GetLang("langcommonview") & "</a>"
   response.write ReportDetailColumn & fieldvalue & ReportDetailColumnEnd
   response.write ReportRowEnd
end sub

' Complete the table
sub DisplayFormTrailer
   response.write ReportTableEnd
end sub

' This routine is used to generate sql to display all languages for a
' specific product or categor
sub GenerateSQL (sql)
   sql = "Select * from " & DBTable
   if which<>"" then
      '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sql = sql & " where " & keyfield & "="& sqlserverprefixn &"" & which
   end if
   sql = sql & " order by lang, " & keyfield
end sub

' for translateproducts, translatecontent, translatecategories
sub SetupTableSpecificvalues (DBTable)
   select case lcase(DBTable)
      case "translateproducts"
         scriptresponder = "shopa_edittranslateproducts.asp"
         keyfield = "CatalogId"
         viewresponder = "shopa_addproduct.asp"
         keytable = "products"
      case "translatecategories"
         scriptresponder = "shopa_edittranslatecategories.asp"
         keyfield = "categoryid"
         keytable = "categories"
         viewresponder = "shopa_addcategory.asp"
      case "translateprodfeatures"
         scriptresponder = "shopa_edittranslateprodfeatures.asp"
         keyfield = "id"
         keytable = "prodfeatures"
         viewresponder = "shopa_editprodfeatures.asp"
   end select
end sub

' generate a link to add a record
sub DisplayaddRecordLink
   dim my_link, fieldvalue, id
   id = ""
   my_link = scriptresponder & "?table=" & DBTable & "&which=" & id & "&IDField=translateid"
   fieldvalue = "<a href=" & my_link &">" & GetLang("langEditadd") & "</a>"
   response.write "<b>" & fieldvalue & "</b><br />"
   response.write "<a href='shopa_editdisplay.asp?table=" & DBTable & "'>" & GetLang("LangEditSelectSetup") & " " & DBTable & "</a>"
   response.write "<br /><br />"
end sub
%>