<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' It is used to format
' products. Special keywords in the form
'*********************************************************************************

sub HtmlProductFormatRow
   ' objrs is already opened pointing to record
   dim Template, rc, url, stayonpage
   StartColumnOrRow
   Template = GetProductTemplate
   if Template = "" then
      SError = GetLang("LangExdNoTemplate")
      ShopError SError
   end if
   if ProductSelect<>"Yes" then
      '7.00 - added xMySite call
	  htmlwrite "<form action=""" & genredirecturl("shopaddtocart.asp") & """ method=""post"">"
   end if
   HtmlWrite "<div class=""productcolwrapper"">"
   ShopTemplateWrite Template, objRs, rc
   htmlwrite "</div>"

   if ProductSelect<>"Yes" then
      htmlwrite "<input type=""hidden"" name=""productid"" value=""" & lngCatalogId & """ />"
      stayonpage = GetConfig("Xproductstayonpage")
      if stayonpage = "Yes" then
	 
		 '700 - 2010.04.16 - Search Stay on page
		 if lcase(request.QueryString("search")) = "yes" then
		    url = "shopdisplayproducts.asp?Search=Yes&page=" & mypage & ""
         else
   		    url = "shopdisplayproducts.asp?page=" & mypage & "&id="& CAT_ID &"&cat="& CATEGORY &""
		 end if

         '6.08a - extra </form> tag removed from line below
         htmlwrite "<input type=""hidden"" name=""ReturnURL"" value=""" & url & """ />"
      end if
      htmlwrite "</form>"
   end if
   EndColumnOrRow
end sub

' Headers for product are displayed here
' 4.00
' June 2, 2002
sub HtmlProductFormatHeader
   htmlwrite Prodtable
   colcount = 0
end sub

sub StartColumnorRow
   if ProductMaxColumns = 1 or colcount = 0 then
      response.write prodrow
   end if

   dim tempcolwidth
   tempcolwidth = cint(100/ProductMaxColumns)
   htmlwrite "<td width="""&tempcolwidth&"%"" class=""vt"">"
end sub

sub EndColumnorRow
   if ProductMaxColumns = 1 then
      htmlwrite "</td>"
      htmlwrite "</tr>"
      exit sub
   end if
   htmlwrite "</td>"
end sub

sub Handle_Product (isub)
   select case isub
      case "FORMATIMAGE"
         FormatImage
      case "FORMATBUTTON"
         if ProductSelect = "Yes" then
            AddSelect
         else
            Formatbutton
         end if
      case "FORMATHYPERLINKS"
         Formathyperlinks
      case "FORMATOVERALLRATING"
         Formatoverallrating
      case "FORMATPRODUCTOPTIONS"
         Formatinventoryproducts dbc, objrs
         Formatproductoptions
      case "FORMATQUANTITY"
         Formatquantity
         '6.50 - product comparison
      case "FORMATCOMPARISON"
         FormatComparison
      case "FORMATRATINGLINKS"
         Formatratinglinks
      case else
         DebugWrite "Unknown sub"
   end select
end sub

' Templates can be passed as request variables
' They can be dependent on the category being displayed
function GetProductTemplate
   dim Template, rTemplate, sql, rs, query

   'Security Patch - 17 April 2008
   rTemplate = CleanChars(request("Template"))

   if rTemplate = "" then
      rTemplate = GetSess("DisplayTemplate")
   end if
   if rTemplate<>"" then
      dim suffix
      suffix = right(rTemplate, 3)
      if lcase(suffix) = "htm" then
         Template = rTemplate
         GetproductTemplate = Template
         SetSess "displayTemplate", rTemplate
         exit function
      end if
   end if

   '600 - insertion of Template for shopdisplayproducts listing 14/10/2005
   '1. Check if they have a Template defined in the Templatelisting field of the product record
   '701 - 2011.06.23 - Enhancement: Speed enhancement
   if (strglobalTemplatelisting > "") and (not isnull(strglobalTemplatelisting)) then
      Template = strglobalTemplatelisting
      GetproductTemplate = Template
      exit function
   end if

   '700 - Quick Admin Order Form
   if getsess("fromquickorder") = "Yes" then
      query = "select hassubproduct from products where CatalogId = " & lngCatalogId
      Set rs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
      rs.open query, dbc, adOpenForwardOnly, adLockReadOnly
      if not rs.eof then
         if rs("hassubproduct") = "Yes" then
            if GetConfig("xproductTemplateinvent") > "" then
               Template = GetConfig("xquickorderproductdisplaytemplateInvent")
            else
               Template = GetConfig("xquickorderproductdisplaytemplate")
            end if
         else
            Template = GetConfig("xquickorderproductdisplaytemplate")
         end if
      else
         Template = GetConfig("xquickorderproductdisplaytemplate")
      end if
      rs.close
      set rs = nothing
   else
      '2. Check if the product is a parent product
      'If it does, use the xproductTemplateinvent Template (if specified)
      'Otherwise use the xproductTemplate Template
	  '701 - 2011.06.23 - Enhancement: Speed enhancement
      if lcase(strglobalproducttype) = "gift" then
         Template = GetConfig("xgiftdisplaytemplate")
      elseif lcase(strglobalproducttype) = "bundled" then
         '700 - product bundles
	     Template = GetConfig("xbundleddisplaytemplate")
      else
         if strglobalhassubproduct = "Yes" then
            if GetConfig("xproductTemplateinvent") > "" then
               Template = GetConfig("xproductdisplayTemplateinvent")
            else
               Template = GetConfig("xproductdisplayTemplate")
            end if
         else
            Template = GetConfig("xproductdisplayTemplate")
         end if
      end if
   end if

   if GetConfig("xcategoryproductTemplates") = "No" then
      GetproductTemplate = Template
      exit function
   end if
   ' because we are really part of shopdisplayproducts we can use open connect and cat_id
   if cat_id<>"" then
      query = "select * from categories where categoryid = " & cat_id
      Set rs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
      rs.open query, dbc, adOpenForwardOnly, adLockReadOnly
      if not rs.eof then
         rTemplate = rs("catproductTemplate")
         if isnull(rTemplate) then
            rTemplate = Template
         end if
         Template = rTemplate
      end if
      rs.close
      set rs = nothing
   end if
   GetproductTemplate = Template
end function
%>