<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Order Tracking Subroutines
'*********************************************************************************

'******************************************************
'6.50 Order Tracking Subroutines
'shopformattracking
'shoptrackingemailCustomer
'shoptrackingemailMerchant
'March 22, 2003
'Oct 2, 2004 fix line 57 check for email address
'*****************************************************
sub ShopFormattracking (dbc, orderid, iAdminflag)
   dim tsql, fields(10), fieldcount, tRs
   tsql = "select * from ordertracking where orderid=" & orderid
   if iadminflag = "" then
      tsql = tsql & " and trackview<>0"
   end if
   tsql = tsql & " order by trackid desc"
   Set trs = Server.CreateObject("ADODB.Recordset")
   trs.open tsql, dbc, adOpenDynamic, adLockOptimistic
   if trs.eof then
      CloseRecordSet trs
      exit sub
   end if
   DisplaytrackingHeader fields, fieldcount
   do while not tRS.eof
      DisplayTrackingRow tRS, fields, fieldcount, iadminflag
      tRS.MoveNext
   loop
   response.write reporttableend
   CloseRecordSet trs
end sub

sub DisplaytrackingRow (trs, fields, fieldcount, adminflag)
   dim fieldvalue, fieldcomment, i, name, emailaddr
   dim editresponder, my_link
   editresponder = "shopa_editrecord.asp"
   fieldcomment = trs("trackcomment")
   response.write "<tr>"
   for i = 0 to fieldcount
      select case ucase(fields(i))
         case "TRACKID"
            fieldvalue = trs(fields(i))
            if adminflag<>"" then
               my_link = editresponder & "?which=" & fieldvalue & "&IDField=trackid&table=ordertracking"
               fieldvalue = "<a href=""" & my_link & """>" & fieldvalue & "</a>"
            end if
         case "TRACKCOMMENT"
            fieldvalue = fieldcomment
         case "TRACKTIME"
            fieldvalue = trs(fields(i))
            fieldvalue = formatdatetime(fieldvalue, vbshorttime)
         case "TRACKNAME"
            if adminflag = "" then
               fieldvalue = trs(fields(i))
            else
               name = trs("trackname")
               emailaddr = trs("trackemail")
               if not isnull(trs("trackemail")) then
                  fieldvalue = "<a href=""mailto:" & emailaddr & """>" & name & "</a>"
               else
                  fieldvalue = name
               end if
            end if
         case else
            fieldvalue = trs(fields(i))
      end select
      response.write ReportDetailColumn & fieldvalue & ReportDetailcolumnEnd
   next
   response.write "</tr>"
end sub

sub DisplaytrackingHeader (fields, fieldcount)
   dim captions(10)
   dim i
   Fields(0) = "trackid"
   Fields(1) = "trackdate"
   Fields(2) = "tracktime"
   Fields(3) = "trackname"
   Fields(4) = "trackcomment"

   '700 - 2010.08.17 - Enhancment: Update language reference
   Captions(0) = GetLang("langtrackid")

   Captions(1) = GetLang("LangDisplayDate")
   captions(2) = GetLang("LangDisplaytime")
   Captions(3) = GetLang("LangCommonName")
   Captions(4) = GetLang("LangTrackingcomment")
   fieldcount = 4
   ShopWriteHeader GetLang("LangTrackingcomment")
   response.write ReportTableDef
   response.write ReportHeadRow
   for i = 0 to fieldcount
      response.write ReportHeadColumn & Captions(i) & ReportHeadColumnEnd
   next
   response.write ReportRowEnd
end sub

' mail to customer
sub ShopTrackingEMailToCustomer (dbc, oid, name)
   dim Template, rs, sql, trackid, bodymessage, emailformat
   dim strname, stremail, CR
   dim acount, attachments
   acount = 0
   CR = getmailCR
   Template = GetConfig("xtrackingmessageTemplate")
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   sql = "select * from ordertracking where orderid=" & oid & " and trackname="& sqlserverprefixn &"'" & name & "'"
   sql = sql & " order by trackid desc "
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if rs.eof then
      CloseRecordSet rs
      exit sub
   end if
   FormatOtherMail Template, RS, BodyMessage
   CloseRecordSet rs

   Template = GetConfig("XtrackingMerchantTemplate")
   sql = "select * from orders where orderid=" & oid
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if not rs.eof then
      strname = rs("ofirstname") & " " & rs("olastname")
      stremail = rs("oemail")
      SetupEmailformat Template, emailformat
      FormatOtherMail Template, RS, Body
      CloseRecordSet rs
      body = bodymessage & "<br />" & Body
      if emailformat<>"HTML" then
         body = replace(body, "<br />", CR)
      end if
      mailtype = GetConfig("xemailtype")
      my_from = GetConfig("xemailname")
      my_fromaddress = GetConfig("xemail")
      my_toaddress = strEmail
      my_to = strname
      my_system = GetConfig("xemailsystem")
      my_subject = GetLang("LangTrackingcomment") & " " & GetLang("langproductorderNumber") & " " & oid
      ExecuteMail mailtype, My_from, my_fromaddress, my_to, my_toaddress, my_subject, body, emailformat, attachments, acount
	  
	  '700 - 2010.08.06 - Enhancement: Adding space to mail
      ShopWriteHeader GetLang("LangMailMailing") & " " & my_to & " " & my_toaddress
   else
      ShopWriteHeader "ERROR: No order exists with that ID"
   end if
end sub

sub ShopTrackingEmailToMerchant (dbc, oid, name, email)
   dim Template, rs, sql, trackid, bodymessage
   dim strname, stremail, CR
   dim acount, attachments
   acount = 0
   CR = getmailCR
   Template = GetConfig("xtrackingmessageTemplate")
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   sql = "select * from ordertracking where orderid=" & oid & " and trackname="& sqlserverprefixn &"'" & name & "'"
   sql = sql & " order by trackid desc "
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if rs.eof then
      CloseRecordSet rs
      exit sub
   end if
   FormatOtherMail Template, RS, BodyMessage
   CloseRecordSet rs

   Template = GetConfig("XtrackingCustomerTemplate")
   sql = "select * from orders where orderid=" & oid
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   strname = name
   stremail = email
   SetupEmailformat Template, emailformat
   FormatOtherMail Template, RS, Body
   CloseRecordSet rs
   body = bodymessage & "<br />" & Body
   if emailformat<>"HTML" then
      body = replace(body, "<br />", CR)
   end if
   mailtype = GetConfig("xemailtype")
   my_to = GetConfig("xemailname")
   my_toaddress = GetConfig("xemail")
   my_fromaddress = strEmail
   my_from = strname
   my_system = GetConfig("xemailsystem")
   my_subject = GetLang("LangTrackingcomment") & " " & GetLang("langproductorderNumber") & " " & oid
   ExecuteMail mailtype, My_from, my_fromaddress, my_to, my_toaddress, my_subject, body, emailformat, attachments, acount
   
   '700 - 2010.08.06 - Enhancement: Adding space to mail
   ShopWriteHeader GetLang("LangMailMailing") & " " & my_to & " " & my_toaddress
end sub
%>