<%option explicit%>
<%response.buffer=true%>
<!--#include file="shop$db.asp"-->
<%ShopOpenDatabase dbc%>
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Display content page
'*********************************************************************************

dim CatalogId, DBTable, IDField, crs, ContentId
dim MessageType
dim Template
'6.08a - moved down below generate meta tags
SetSess "CurrentURL","shopcontent.asp"
MessageType=GetTextField("type")

'VP-ASP Security Patch - 8 July 2008
ContentId = CleanChars(request("ContentId"))

'700 - SEO
if MessageType = "" then
   if getsess("seotype") <> "" then
      MessageType = getsess("seotype")
   end if
end if

if ContentId > "" then
   if not isnumeric(ContentId) then
      ContentId=""
	  ShopPageHeader
	  HandleError "Content ID must be a numeric value"
	  ShopPageTrailer
	  response.end
	end if
end if
if MessageType="" and ContentId = "" then
   ShopPageHeader
   HandleError GetLang("LangRecordNotFound")
   ShopPageTrailer
   response.end
end if

'6.08a - Generate Dynamic Meta tags
SetupDynamicContent dbc, ContentId, MessageType
ShopPageHeader
GenerateContentSQL sql
OpenRecordSet dbc, crs, sql

if crs.eof then
   if trim(MessageType) <> "" then
      handleerror getlang("LangRecordNotFound") & " " & MessageType
   else
      handleerror getlang("LangRecordNotFound") & " " & contentid
   end if
else
   Formatcontent crs
end if

CloseRecordSet  crs
ShopPageTrailer
ShopCloseDatabase dbc

'write a message
sub HandleError (msg)
   ShopWriteError msg
end sub

'Use temaplte or just displaye it
sub FormatContent (crs)
   dim message, message2, image
   if ContentId = "" then
      dim GetContentSQL, GetContentRS
	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      GetContentSQL = "select ContentId from content WHERE MessageType = "& sqlserverprefixn &"'" & tosql(MessageType,"Text") & "'"
      OpenRecordSet dbc, GetContentRS, GetContentSQL
      if GetContentRS.eof then
	     ShopErrror "There has been an error retrieving the ID for this content."
      else
	     ContentId = GetContentRS("ContentId")
      end if
      CloseRecordSet GetContentRS
   end if
   message=TranslateLanguage(dbc, "content", "message","ContentId", ContentId, crs("message"))
   message2=TranslateLanguage(dbc, "content", "message2","ContentId", ContentId, crs("message2"))
   ContentId=crs("ContentId")
   image=crs("ContentImage")
   if isnull(image) then image=""
   '6.09 - Add breadcrumb / 6.50 - added config option to turn breadcrumb on/off
   if GetConfig("xbreadcrumbs") = "Yes" then
      '6.50 - advanced session handling
	  HtmlWrite "<div class=""breadcrumb""><a href=""" & GetConfig("xhome") & addwebsesslinkfirst & """>" & GetLang("langcommonhome") & "</a>&nbsp;" & SubCatSeparator & "&nbsp;" & RemoveHtml(message,"<br />") & "</div>"
   end if
%>
<h1><%=message%></h1>
<div id="contentpage">
<%
   if image<>"" then
      FormatImage image
   end if
%>
			<%=message2%>
</div>
<%


end sub

sub GetTemplate (crs, Template)
end sub

sub FormatImage (image)
   htmlwrite "<img class=""right_image"" src="""& image &""" align=""right"">"
end sub

'get last non hidden news or whatever
sub GenerateContentSQL (sql)
   if ContentId > "" then
      sql="select * from content where ContentId=" & ContentId
   else
      '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sql="select * from content where MessageType="& sqlserverprefixn &"'" & tosql(MessageType,"Text") & "'"
   end if
   sql=sql & " and hide=0 "

   '700 - 2010.06.09 - Enhancement: Admin user activities, statstic, admin/front contents compatitable with adjustdate and adjusttime
   dim indatetime
   indatetime = getnowindate
   sql = sql & " and (cnewsStartDate is null or cnewsEndDate is null or (cnewsStartDate <= "& DateDelimit(indatetime) &" and cnewsEndDate >= "& DateDelimit(indatetime) &" )) "

   sql = sql & " and (content.contactid = '"& getsess("CustomerID") &"' or content.contactid = '' or content.contactid is null)"
   sql = sql & GenerateCustomerMatchSQL ("content.contentgroups","content.excontentgroups","content.loggedin","and")
   
   if GetConfig("xselectproductsbylanguage")="Yes" and GetSess("language")<>"" then
      '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sql=sql & " and (contentlanguage="& sqlserverprefixn &"'" & GetSess("language") & "'"
      sql=sql & " or contentlanguage is null)"
   end if

   '7.01 - 2010.10.05 - To support multistores to contents,blog,news
   if GetConfig("xproductmatch") = "Yes" then
      sql = sql & " and "
      GeneratecontentsProductmatchsql sql
   end if
   
   sql=sql & " order by ContentId desc"
end sub

'6.08 - Impressions weren't writing correctly.
sub WriteImpressions
end sub

'6.09 - added function to clean HTML from message to be used in breadcrumb
function RemoveHtml(itemname, CR)
   dim workrecord, firstchar, morefields, pos, endpos, length
   dim token
   if ucase(GetSess("emailformat"))="HTML" then
      RemoveHtml=itemname
      exit function
   end if

   '6.50 - check that itemname has data in it before replacing
   if itemname > "" then
      workrecord=replace(itemname,"<br />",CR)
      workrecord=replace(itemname,"<br>",CR)
   end if

   if GetConfig("xemailRemoveHtml")<>"Yes" then
      RemoveHtml=workrecord
      exit function
   end if
   pos=1
   morefields = True
   do while morefields = True
      pos=1
      pos = InStr(pos, workrecord, "<")
      if pos > 0 then
         endpos = InStr(pos, workrecord, ">")
         if endpos=0 then
            morefields=false
         else
            length = endpos - pos + 1
            token = Mid(workrecord, pos, length)
            workrecord=replace(workrecord,token,"")
         end if
      else
         morefields=false
      end if
   loop
   RemoveHtml=workrecord
end function

'7.01 - 2010.10.05 - To support multistores to contents,blog,news
sub GeneratecontentsProductmatchsql (sql)
   dim shops(50), shopcount, i
   ParseRecord xproductmatch, shops, shopcount, "," ' get all shops allowed
   sql = sql & " ("
   for i = 0 to shopcount -1
      if i>0 then
         sql = sql & " or "
      end if
	  if instr(lcase(xdatabasetype),"mysql") > 0 then
	     sql = sql & " concat(',',productmatch,',') like '%," & shops(i) & ",%'"
	  else
	     sql = sql & " ',' + productmatch + ',' like "& sqlserverprefixn &"'%," & shops(i) & ",%'"
	  end if
   next
   sql = sql & " or (productmatch is null or productmatch = ''))"
end sub
%>